%ext ck1
%version 1.31

######

#Big versitile status window patch:
# Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

# Patch in the name of the status dialog text file, you'll need to create a file with this name and put your status
# text in it or Keen will crash. An example status file can be found in this directory.
%patch $13084  "STATUS.CK1" $00 

# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks) 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00   # Show status window (0E6A) 
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   # Show score (0E98) 
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $8B $46 $FE $05 $01 $00 $50 $89 $F0 $05 $1A $00 $50   # Show extra Keen score (0EB3) 
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52 
               $E8 $E1 $02 $83 $C4 $08 
                                       $31 $FF $3B $3E $C6 $AA $7D $29 $83 $FF   # Show Keens (0ED6) 
               $06 $7D $24 $B8 $7B $00 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $01 $00 $01 $F0 $50 $E8 $2C 
               $AC $83 $C4 $06 $47 $EB $D1 
%patch $0F07                               $B8 $41 $01 $83 $3E $94 $AA $00 $74   # Draw the joystick 
               $03 $B8 $3D $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $10 $00 $50 $E8 $0D $AA $83 $C4 $06 
                                                                           $B8   # Draw the battery 
               $42 $01 $83 $3E $9C $AA $00 $74 $03 $B8 $3E $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $13 $00 
               $50 $E8 $E5 $A9 $83 $C4 $06 
                                           $B8 $43 $01 $83 $3E $96 $AA $00 $74   # Draw the vacuum 
               $03 $B8 $3F $01 $50 $8B $46 $FE $05 $03 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $16 $00 $50 $E8 $BD $A9 $83 $C4 $06 
                                                                           $B8   # Draw the whiskey 
               $44 $01 $83 $3E $98 $AA $00 $74 $03 $B8 $40 $01 $50 $8B $46 $FE 
               $05 $03 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $19 $00 
               $50 $E8 $95 $A9 $83 $C4 $06 
%patch $0FA7                               $B8 $2E $02 $83 $3E $9E $AA $00 $74   # Keycard A 
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard B 
               $2E $02 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $2E $02 $83 $3E $A2 $AA $00 $74   # Keycard C 
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard D 
               $2E $02 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $B8 $0B $00 $83 $3E $9A $AA $00 $74   # Pogo stick 
               $03 $B8 $9F $01 $50 $8B $46 $FE $05 $08 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $0B $00 $50 $E8 $CD $A8 $83 $C4 $06 
                                                                           $8B   # Draw ammo 
               $46 $FE $05 $0B $00 $50 $89 $F0 $05 $06 $00 $50 $31 $C0 $50 $FF 
               $36 $C8 $AA $E8 $2E $01 $83 $C4 $08 
                                                   $B8 $9E $01 $50 $8B $46 $FE   # Draw raygun (replace first two bytes 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $03 $00   # with $EB $1C if you don't want to 
               $50 $E8 $95 $A8 $83 $C4 $06                                       # draw the raygun on the status screen) 

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   # Wait for a key, then return 
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 

#Locations and tiles used in the patch
%patch $0E53 $0D $00 #Window height
%patch $0E57 $1C $00 #Window width
%patch $0E9C $01 $00 #Score Y position
%patch $0EA2 $0A $00 #Score X position 
%patch $0EB7 $01 $00 #Extra life Y position
%patch $0EBD $1A $00 #Extra life X position
%patch $0EE0 $06 #Maximum number of Keens to show
%patch $0EE4 $7B $00 #Sprite to use for Keens left
%patch $0EEB $03 $00 #Y position of Keens 
%patch $0EF9 $01 $00 #X position if Keens
%patch $0F08 $41 $01 #Tile for no joystick
%patch $0F12 $C0 $01 #Tile for got joystick
%patch $0F19 $03 $00 #Y position of Joystick
%patch $0F20 $04 $00 #Joystick Y offset (pixels)
%patch $0F26 $10 $00 #X position of Joystick
%patch $0F30 $42 $01 #Tile for no battery
%patch $0F3A $C1 $01 #Tile for got battery
%patch $0F41 $03 $00 #Y position of Battery
%patch $0F48 $04 $00 #Battery Y offset (pixels)
%patch $0F4E $13 $00 #X position of Battery
%patch $0F58 $43 $01 #Tile for no  Vacum
%patch $0F62 $C2 $01 #Tile for got  Vacum
%patch $0F69 $03 $00 #Y position of  Vacum
%patch $0F70 $04 $00 # Vacum Y offset (pixels)
%patch $0F76 $16 $00 #X position of  Vacum
%patch $0F80 $44 $01 #Tile for no  Whiskey
%patch $0F8A $C1 $01 #Tile for got  Whiskey
%patch $0F91 $03 $00 #Y position of  Whiskey
%patch $0F98 $04 $00 # Whiskey Y offset (pixels)
%patch $0F9E $19 $00 #X position of  Whiskey
%patch $0FA8 $0B $00 #Tile for no  Keycard A
%patch $0FB2 $A8 $01 #Tile for got  Keycard A
%patch $0FB9 $07 $00 #Y position of  Keycard A
%patch $0FC0 $04 $00 # Keycard A Y offset (pixels)
%patch $0FC6 $13 $00 #X position of  Keycard A
%patch $0FD0 $0B $00 #Tile for no  Keycard B
%patch $0FDA $A9 $01 #Tile for got  Keycard B
%patch $0FE1 $07 $00 #Y position of  Keycard B
%patch $0FE8 $04 $00 # Keycard B Y offset (pixels)
%patch $0FEE $17 $00 #X position of  Keycard B
%patch $0FF8 $0B $00 #Tile for no  Keycard C
%patch $1002 $AA $01 #Tile for got  Keycard C
%patch $1009 $09 $00 #Y position of  Keycard C
%patch $1010 $04 $00 # Keycard C Y offset (pixels)
%patch $1016 $13 $00 #X position of  Keycard C
%patch $1020 $0B $00 #Tile for no  Keycard D
%patch $102A $AB $01 #Tile for got  Keycard D
%patch $1031 $09 $00 #Y position of  Keycard D
%patch $1038 $04 $00 # Keycard D Y offset (pixels)
%patch $103E $17 $00 #X position of  Keycard D
%patch $1048 $0B $00 #Tile for no  Pogo
%patch $1052 $9F $01 #Tile for got  Pogo
%patch $1059 $08 $00 #Y position of  Pogo
%patch $1060 $04 $00 # Pogo Y offset (pixels)
%patch $1066 $0B $00 #X position of  Pogo
%patch $1073 $0B $00 #Y position of ammo text
%patch $1079 $06 $00 #X position of ammo text
%patch $1091 $07 $00 #Y position of raygun
%patch $1098 $04 $00 #Y offset of raygun (pixels)
%patch $109E $03 $00 #X position of raygun

#######

###
# KEEN DUCKS INSTEAD OF SHOOTING
# AMMO USED FOR BONUS ITEMS INSTEAD -- 5 AMMO = LOTS OF POINTS
###


#Make Keen act as if he has no shots.
#%patch $3E30 $EB
# and don't play the 'click-out-of-ammo' sound either
#%patch $3E5B  $90 $90 $90

#Remove shooting entirely:
%patch $3E36  $90 $90 $90     #stop the shooting sound
%patch $3E5B  $90 $90 $90     #and don't play the 'click-out-of-ammo' sound
%patch $3E3B  $90 $90 $90 $90 #stop losing a shot [Infinite ammo]
%patch $3E4F  $90 $90 $90     #don't spawn a shot

#Set Keen's shots to zero on exiting all levels
%patch $4F43 $31 $C0 $A3 $9E $AA $A3 $A0 $AA 
             $A3 $A2 $AA $A3 $A4 $AA $A3 $C8 
             $AA $90 $90 $90 $90 $90 $90 $90 
             $90 $90 $90 

###

#Change sprite used to spawn Keen
#%patch $8FB6 $00 $01
#%patch $AB46 $00 $01

#TileInfo
#%patchfile 0x130F8 retrosis.tli

#Pogo acts normally in God Mode
%patch $3F4E  $EB

#Keen always has a pogo
%patch $900E  $01 $00 

#Vorticon Jump Height
%patch $1C49  $90 $00

#Yorp Jump Height
%patch $1964 255

#Number of shots each raygun gives:
%patch $44A4 $01

# Change the teleporter so it works within the level (updated 24/09/03) 
%patch $8919                           $89 $F0 $F7 $2E $08 $6C $01 
   $F8 $D1 $E0 $C4 $1E $4C $6C $01 $C3 $26 $8B $07 $50 $88 $E0 $98 
   $99 $01 $F0 $83 $D2 $00 $B1 $0C $E8 $16 $58 $89 $16 $E4 $6E $A3 
   $E2 $6E $05 $00 $B0 $83 $D2 $FF $A3 $D4 $6E $89 $16 $D6 $6E $58 
   $98 $99 $01 $F8 $83 $D2 $00 $B1 $0C $E8 $F5 $57 $89 $16 $E0 $6E 
   $A3 $DE $6E $05 $00 $70 $83 $D2 $FF $A3 $D0 $6E $89 $16 $D2 $6E 
   $C3 
%patch $4572  $E8 $A4 $43 $EB $13 $90 

###

# Change the controls to: Space, shoot; Enter, status.
%patch $1251  $48
%patch $7FA3  $48
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DCC  $90 $90
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00

#Keen 1 background tiles behave like Keen 3
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE 
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01 

%patch $4482  $E9 $74 $FF 
%patch $44BA  $E9 $3C $FF 
%patch $4513  $E9 $E3 $FE 

%patch $28EC                  $26 $8B $07 $B6 
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07 
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C 
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90 

#This is the color palette: 16 entries of r, g, b (each 0-63) 
%patch $13054 
       00 00 00 #black 
       00 00 42 #blue 
       00 42 00 #green 
       16 16 36 #cyan 
       42 00 00 #red 
       63 24 00 #magenta 
       42 21 00 #brown 
       42 42 42 #bright gray 
       21 21 21 #gray 
       21 21 63 #bright blue 
       21 63 21 #bright green 
       21 63 63 #bright cyan 
       63 21 21 #bright red 
       63 40 00 #pink 
       63 63 21 #yellow 
       63 63 63 #white 
#Set the palette when we go into graphics mode 
%patch $6E46  $E8 $D3 $D5 $90 $90 
#Code to set graphics mode and set the palette 
%patch $441C                  $B8 $0D $00 $CD 
              $10 $B8 $12 $10 $B9 $08 $00 $BB 
              $00 $00 $8C $DA $8E $C2 $BA $04 
              $00 $CD $10 $BB $18 $00 $BA $1C 
              $00 $CD $10 $C3 

#Stop the doors bouncing Keen:
%patch $43A4  $E9 $D1 $01
%patch $2F31  $E8 $9D $E1 $90 $90
%patch $2FE6  $E8 $0B $E1 $90 $90
%patch $10D1  $81 $3E $54 $82 $C4 $45 $75 $15 
              $8B $87 $6E $05 $48 $48 $3D $04 
              $00 $73 $0A $89 $C3 $D1 $E3 $83 
              $BF $9E $AA $01 $C3 $83 $BF $86 
              $18 $00 $C3 $81 $3E $54 $82 $C4 
              $45 $75 $15 $8B $87 $6E $05 $48 
              $48 $3D $04 $00 $73 $0A $89 $C3 
              $D1 $E3 $83 $BF $9E $AA $01 $C3 
              $83 $BF $FA $0E $00 $C3 

# Doors disappear instantly instead of sliding
%patch $286B $90 $90 $90

#Make doors open like in Keen 3 (Replacement tile is tile next to door)
%patch $28EC                  $26 $8B $07 $B6
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90

# Bridge Block
%patch $4AEE $04 $02
%patch $4B3D $04 $02

# Bridge Switch
%patch $36DB $36 $01
%patch $36E0 $37 $01
%patch $36FC $37 $01
%patch $3716 $36 $01

# Lightswitch Tile
%patch $36D6 $35 $01

# What sprite property activates the chain:
%patch $22C8 $05 #Chain killed by butler bot

#Change the block tiles
#%patch $23CD $BA $01 #top l corner
#%patch $2436 $BB $01 #top middle
#%patch $24B6 $BC $01 #top r corner
#%patch $23EF $C7 $01 #bottom l corner
#%patch $2458 $C8 $01 #bottom middle
#%patch $24D8 $C9 $01 #bottom left
#Change the tiles the block leaves behind
#%patch $23AB $AD $01 #left
#%patch $2414 $AE $01 #middle
#%patch $2494 $AF $01 #right

#Change the block tiles
%patch $23CD $BA $01 #top l corner
%patch $2436 $BB $01 #top middle
%patch $24B6 $BC $01 #top r corner
%patch $23EF $C7 $01 #bottom l corner
%patch $2458 $C8 $01 #bottom middle
%patch $24D8 $C9 $01 #bottom r corner
#Change the tiles the block leaves behind
%patch $23AB $AD $01 #left
%patch $2414 $AE $01 #middle
%patch $2494 $AF $01 #right

#Location of block left end from chain
%patch $238D $FF $FF
#Location of middle of block END from chain, number used =
#$FF $FF MINUS [blocks wanted - 5] here FD = FF - [8 - 5] [$04 = no blocks]
%patch $23F4 $00 $00
#Location of block right end, from chain, use $FF $FD for -ve values
%patch $2476 $01 $00

#Draw only one tile in the middle (experiment further for documentage)
%patch $2465 $00

#Number of 'ticks' block falls [i.e, four ticks of one tile = 4x1 = 4 tile total is standard]
%patch $24E8 $01

#Top right tile vertical position [None of these can be -ve!]
#%patch $23B5 $06
#Top middle tile vertical position
#%patch $241E $06
#Top left tile vertical position
#%patch $249E $06
#Bottom left tile vertical position
#%patch $23D7 $07
#Bottom middle tile vertical position
#%patch $2440 $07
#Bottom right tile vertical position
#%patch $24C0 $07

#%patch $23C3 $05

#Up right icecube
#Shoots right only
%patch $2110 $00 $00 #Up speed
%patch $2115 $80 $00 #Right speed

#Up left icecube
#Shoots left only
%patch $2134 $00 $00 #Up speed
%patch $2139 $80 $FF #Left speed

#Down icecubette
#Shoots down only
%patch $2251 $00 $00 #Speed left
%patch $2256 $C8 $00 #Speed down

#Up icecube
%patch $211C $80 $FF #Up speed

#Icecube behaviour
#%patch $20D6 $05 $00 #Push keen
# Icecubes continues on its merry way while colliding with player
%patch $22A6 $C3

#Existing ice cubes continue flight even offscreen
%patch $3340 $83 $3E $20 $82 $09 $7C $13 $83 $3E $20 $82 $0F $74 $0C $90

#Cannon fires, even offscreen, only makes shooting sound while onscreen
%patch $207A $28 #4A
%patch $2084 $1E #40
%patch $208F $13 #35
%patch $2099 $09 #2B

#Cube doesn't make smash sound
%patch $229D $90 $90 $90 

#Ice cannon shoot rate
%patch $2058 $08

###
#Yorp:
###

%patch $18DE 48  #Start

%patch $19E7 48  #Looking around
%patch $19E4 3   #Frames used -1
%patch $19E0 8   #Animation speed

%patch $1993 52  #Walking right
%patch $199B 54  #Walking left
%patch $19A5 0   #Frames used -1 [Left and right]
%patch $19A1 4   #Animation speed

%patch $1A3A 56  #Stunned
%patch $1A37 1   #Frames used -1
%patch $1A33 4   #Animation speed

%patch $1A8A 58  #Shot
%patch $1A85 2   #Frames used

#####
#Garg
#####

#Garg always jumps, whether it's running or not:
%patch $1B39 $90 $90
#Gargs fly
#%patch $1B40 $90 $90

#####
#Exit
#####

%patch $4128 $AF $01 #Keen exit door tile 1
%patch $414C $BC $01 #and tile 2
%patch $4176 $DD $00 #exit top blank tile
%patch $41A0 $DD $00 #Exit bottom blank tile

%patch $7C07  $83 $EC $20

%patch $7D13              $31 $F6 $C4 $3E $4C $6C $8B $16 $08 $6C $A1 $58 $6C
%patch $7D20  $F7 $E2 $89 $C1 $09 $C9 $75 $03 $E9 $DA $00 $26 $8B $05 $C7 $46
%patch $7D30  $E0 $00 $00 $A9 $00 $80 $74 $05 $C7 $46 $E0 $01 $00 $25 $FF $7F
%patch $7D40  $75 $03 $E9 $B9 $00 $89 $46 $FC $3D $10 $00 $7C $03 $E9 $85 $00
%patch $7D50  $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $75 $03 $E9 $A0 $00 $26 $C7
%patch $7D60  $05 $00 $00 $83 $7E $E0 $00 $74 $03 $E9 $92 $00 $89 $FB $43 $43
%patch $7D70  $26 $8B $07 $25 $FF $7F $3B $46 $FC $75 $47 $26 $C7 $07 $00 $00
%patch $7D80  $03 $1E $08 $6C $03 $1E $08 $6C $26 $C7 $07 $00 $00 $4B $4B $26
%patch $7D90  $C7 $07 $00 $00 $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26
%patch $7DA0  $C7 $07 $4E $00 $43 $43 $26 $C7 $07 $4F $00 $03 $1E $08 $6C $03
%patch $7DB0  $1E $08 $6C $26 $C7 $07 $51 $00 $4B $4B $26 $C7 $07 $50 $00 $07
%patch $7DC0  $EB $3C $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07
%patch $7DD0  $4D $00 $07 $EB $29 $3D $65 $00 $7C $24 $3D $74 $00 $7F $1F $2D
%patch $7DE0  $64 $00 $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $74 $11 $06 $C4 $1E
%patch $7DF0  $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07 $86 $01 $07 $49 $47
%patch $7E00  $47 $46 $E9 $1F $FF $EB $4A 

# Do not spawn DONE markers (Flags version)
# Place this AFTER the flags patch
# Single Marker:
%patch $7DCD  $90 $90 $90 $90 $90

# 2x2 Marker:
%patch $7D9F  $90 $90 $90 $90 $90
%patch $7DA6  $90 $90 $90 $90 $90
%patch $7DB4  $90 $90 $90 $90 $90
%patch $7DBA  $90 $90 $90 $90 $90 

#Gargs don't look around [But may turn around suddenly and chase Keen] 
%patch $1B6C  $00 

#Gargs anywhere will charge toward Keen after lokking around 
#[Don't check if Garg can see Keen before charging] 
%patch $1B93 $90 $90 $90 $90 $90 $90 $90 $90

#Garg's charge speed?
#%patch $1B9F $01 $00

#%patch $1B7A $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
#             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
#             $90 $90 $90 $90 $90 $90 $90 

#%patch $1B74 $5D $C3

#Garg calls randomiser function and ignores result
#%patch $1B74 $E8 $57 $A7
#%patch $1B77 $3B $06 $14 $5B
#%patch $1B7B $73 $02
#%patch $1B7D $7E $00
#%patch $1B7F $5D $C3

#Garg calls randomiser function and ignores result
#%patch $1B74 $E8 $57 $A7         # call C0CE
#%patch $1B77 $3B $06 $14 $5B
#%patch $1B7B $73 $26
#%patch $1B7D $7E $2A
#%patch $1B7F $5D $C3

#%patch $1BA9 $90 $90 $90 $90 $90 $90 $90 
# Garg just stands around being mad
#%patch $1BB4 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 

#Random garg charging direction
#%patch $1BA9 $E8 $22 $A5 #call $C0CE (randomiser function)
       #$1BA9 $90 $90 $90
       #$1BAC $3B $06 $14 $5B  #cmp ax, [5B14]
       #$1BAC $90 $90 $90 $90
       #$1BB0 $73 $14
       #$1BB2 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90



# Garg just stands around being mad
#%patch $1BB4 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 
#             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 

# Garg doesn't charge
# :0001.1B9B C7064082DC00           mov word ptr [8240], 00DC
#%patch $1B9B $90 $90 $90 $90 $90 $90 

# Always compare garg position with zero, thus always charges right
#%patch $1BA9 $B8 $00 $00

# Player score init
# :0001.9004 C706C8AA0000           mov word ptr [AAC8], 0000

# Garg chooses random directions
%patch $1BA9 $E8 $22 $A5      # call $C0CE ($C0CE - $1BAC = $$A522)
%patch $1BB0 $38 $06 $14 $5B  # cmp ax, [5B14]

# Music TSR interrupts
#%patch $BE97 $65
#%patch $BEE2 $65

###
# MULTIPLE TILESET PATCH
###

#xtratil2.bin contains extra tile code
%patchfile $13C2 xtratil2.bin
%patch $13C0 $95 $01
%patch $676 $E8 $49 $0D 

#Files used: (.TLI, TLG and TLA)
#If files are not present the fame will not load them. .TLG
#files are tilesets, .TLI files are tileinfo and .TLA are tile anim
#properties.
#Here use a different set of files for each level; for example
#level01 uses TLSET01.TLG, level03 TLSET03.TLG, and so on. You
#do NOT have to use different files for each level, just change
#the "xx" patch.
%patch $14F55 "TLSETxx.TLS" $00  #Basic name
                           "00"  #LEVEL80, 81 and 90.CK1
                           "01"  #LEVEL01.CK1
                           "01"  #LEVEL02.CK1
                           "01"  #LEVEL03.CK1
                           "01"  #LEVEL04.CK1
                           "01"  #LEVEL05.CK1
                           "01"  #LEVEL06.CK1
                           "01"  #LEVEL07.CK1
                           "01"  #LEVEL08.CK1
                           "01"  #LEVEL09.CK1
                           "01"  #LEVEL10.CK1
                           "01"  #LEVEL11.CK1
                           "01"  #LEVEL12.CK1
                           "01"  #LEVEL13.CK1
                           "01"  #LEVEL14.CK1
                           "01"  #LEVEL15.CK1

###

#sprites below INGAME type #9 operate off screen 
%patch $3347 $90 $90 $90  $90 $90 $90 $EB $0B 

#########################
# POPUP MESSAGE PATCHES #
#########################

#Change tile yorp message head becomes
%patch $455E $20 $01
#And Garg
%patch $4547 $20 $01

#First Yorp message: [Level 2] -7 lines
%patch $15080 "                    "
%patch $15096 "      O HAI! ^^     "
%patch $150AC "                    "
%patch $150C2 "     Found you a    "
%patch $150D8 "     mustards...    "
%patch $150EE "                    "
%patch $15104 "  But you eated it. "

#Second Yorp message [level 6] -7 lines
%patch $1511A "A message echoes in "
%patch $15130 "your head:          "
%patch $15146 "                    "
%patch $1515C "The Teleporter in   "
%patch $15172 "the ice will send   "
%patch $15188 "you to the dark side"
%patch $1519E "of Mars             "

#Third Yorp message: [level 9] -7 lines
%patch $151B4 "                    "
%patch $151CA "     NOOOO! D:      "
%patch $151E0 "  They be stealin'  "
%patch $151F6 "    my ketchup!     "
%patch $1520C "                    "
%patch $15222 "                    "
%patch $15238 "                    "

#Sixth Yorp message: [level 15] -6 lines
%patch $153DB "                    "
%patch $153F1 "     That's OK!     "
%patch $15407 "       I HATE       "
%patch $1541D "     SAUERKRAUT     "
%patch $15433 "                    "
%patch $15449 "                    "

###########################
# SPRITE CLIPPING PATCHES #
###########################


#keen rides cubes
%patch $467A $57 $56 $E8 $E9BDW $59 $59 $B8
             $0002W  #sound on contact
            #$EB $D  #to play sound
             $EB $13 #to not play sound (must include one of the $EB lines)

#Cubes don't interact with any other sprite
%patch $213E $2045W 

#butler/tankbots push keen smoothly (meep style)
%patch $4646 $57 $56 $E8 $EB92W $59 $59 $B8
       $0002W  #sound on contact
      #$EB $41 #to play sound
       $EB $47 #to not play sound (must include one of the $EB lines)    

####
# BONUS ITEMS
####

#Parts levels (Part removed if you die in this level)
%patch $4F69 8  #Joystick
%patch $4F70 3  #Battery
%patch $4F75 4  #Vacum
%patch $4F7C 16 #Everclear

#Ammo counter starting value
%patch $9008  $01 $00

####
# IN-LEVEL SCORE COUNTER
####

#Number of keens at start (0)
%patch $9002 $00 $00

#number lives counts deaths
%patch $8041 $FF $06 $C6 $AA

#Display death count in extra score
%patch $0FA7 $A1 $C6 $AA $33 $D2 $52 $50 $90
                 $90 $90 $90 $90 $90 $90 $90 $90

#keen death A, reset score
%patch $427D $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90

#keen death B, reset score
%patch $42BB $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90

#level load, save temp score
%patch $4BAE $66 $A1 $CA $AA $66 $A3 $00 $AF $66 $33 $C0 $66 $A3 $35 $51 $66 $A3 $3E $56 $A3 $14 $5B $90 

### FOR NOW, SKIP END SEQUENCE

%patch $81CE $00     #Ignore ending sequence, go to game over.

#Title Image @ 0,0
%patch $97B2 $00 $00 #V location(Pixels)
%patch $97B6 $04 $00 #H location (8x8 locks) 

%end
